"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  addToSchema: () => addToSchema,
  plugin: () => plugin,
  validate: () => validate
});
module.exports = __toCommonJS(src_exports);
var import_path = require("path");
var import_plugin_helpers = require("@graphql-codegen/plugin-helpers");
var import_amplience_graphql_codegen_common2 = require("amplience-graphql-codegen-common");
var import_change_case2 = require("change-case");
var import_graphql = require("graphql");
var import_terraform_generator2 = require("terraform-generator");

// src/lib/visitor.ts
var import_amplience_graphql_codegen_common = require("amplience-graphql-codegen-common");
var import_change_case = require("change-case");
var import_terraform_generator = require("terraform-generator");
var createObjectTypeVisitor = ({
  tfg,
  hostname,
  visualization,
  contentRepositories,
  slotRepositories,
  contentRepositoriesForEach,
  slotRepositoriesForEach,
  schemaSuffix
}) => (node) => {
  var _a2, _b, _c, _d, _e;
  const directive = (0, import_amplience_graphql_codegen_common.maybeDirective)(node, "amplienceContentType");
  if (!directive)
    return null;
  const name = (0, import_change_case.snakeCase)(node.name.value);
  const isSlot = ((_a2 = (0, import_amplience_graphql_codegen_common.maybeDirectiveValue)(directive, "kind")) == null ? void 0 : _a2.value) === "SLOT";
  const isAutoSync = ((_b = (0, import_amplience_graphql_codegen_common.maybeDirectiveValue)(directive, "autoSync")) == null ? void 0 : _b.value) ?? true;
  const schema = tfg.resource("amplience_content_type_schema", name, {
    body: (0, import_terraform_generator.fn)(
      "file",
      `\${path.module}/schemas/${(0, import_change_case.paramCase)(node.name.value)}${schemaSuffix ? "-" + schemaSuffix : ""}.json`
    ),
    schema_id: (0, import_amplience_graphql_codegen_common.typeUri)(node, hostname),
    validation_level: isSlot ? "SLOT" : "CONTENT_TYPE",
    auto_sync: isAutoSync
  });
  const shouldVisualize = (_c = (0, import_amplience_graphql_codegen_common.maybeDirectiveValue)(
    directive,
    "visualizations"
  )) == null ? void 0 : _c.value;
  const iconUrl = directive ? (_d = (0, import_amplience_graphql_codegen_common.maybeDirectiveValue)(directive, "icon")) == null ? void 0 : _d.value : void 0;
  const dynamicVisualization = visualization == null ? void 0 : visualization.find((0, import_amplience_graphql_codegen_common.hasProperty)("for_each"));
  const contentType = tfg.resource("amplience_content_type", name, {
    content_type_uri: schema.attr("schema_id"),
    label: (0, import_change_case.capitalCase)(node.name.value),
    icon: iconUrl ? { size: 256, url: iconUrl } : void 0,
    status: "ACTIVE",
    'dynamic"visualization"': shouldVisualize && dynamicVisualization ? dynamicVisualizationBlock(dynamicVisualization) : void 0,
    visualization: shouldVisualize && visualization ? visualization.filter((v) => !v.for_each) : void 0
  });
  const repositoryName = (_e = (0, import_amplience_graphql_codegen_common.maybeDirectiveValue)(
    directive,
    "repository"
  )) == null ? void 0 : _e.value;
  if ((contentRepositories == null ? void 0 : contentRepositories.length) && !isSlot) {
    tfg.resource("amplience_content_type_assignment", name, {
      content_type_id: contentType.id,
      repository_id: (contentRepositories.find((r) => r.name === repositoryName) ?? contentRepositories[0]).id
    });
  }
  if ((slotRepositories == null ? void 0 : slotRepositories.length) && isSlot) {
    tfg.resource("amplience_content_type_assignment", name, {
      content_type_id: contentType.id,
      repository_id: (slotRepositories.find((r) => r.name === repositoryName) ?? slotRepositories[0]).id
    });
  }
  if (contentRepositoriesForEach && !isSlot) {
    tfg.resource("amplience_content_type_assignment", name, {
      for_each: (0, import_terraform_generator.arg)(contentRepositoriesForEach),
      content_type_id: contentType.id,
      repository_id: (0, import_terraform_generator.arg)("each.value")
    });
  }
  if (slotRepositoriesForEach && isSlot) {
    tfg.resource("amplience_content_type_assignment", name, {
      for_each: (0, import_terraform_generator.arg)(slotRepositoriesForEach),
      content_type_id: contentType.id,
      repository_id: (0, import_terraform_generator.arg)("each.value")
    });
  }
  return null;
};
var maybeArg = (value, ...prefixes) => ["var.", "local.", ...prefixes].some((prefix) => value.startsWith(prefix)) ? (0, import_terraform_generator.arg)(value) : value;
var dynamicVisualizationBlock = (visualization) => ({
  for_each: (0, import_terraform_generator.arg)(visualization.for_each),
  content: {
    label: maybeArg(visualization.label, "visualization"),
    templated_uri: maybeArg(visualization.templated_uri, "visualization"),
    default: visualization.default
  }
});

// src/index.ts
var _a;
var addToSchema = (_a = import_amplience_graphql_codegen_common2.schemaPrepend.loc) == null ? void 0 : _a.source.body;
var plugin = (schema, _documents, {
  hostname = "https://schema-examples.com",
  visualization,
  content_repositories,
  slot_repositories,
  schemaSuffix,
  add_required_provider = true
}) => {
  const astNode = (0, import_plugin_helpers.getCachedDocumentNodeFromSchema)(schema);
  const tfg = new import_terraform_generator2.TerraformGenerator(
    add_required_provider ? {
      required_providers: { amplience: (0, import_terraform_generator2.map)({ source: "labd/amplience" }) }
    } : void 0
  );
  const contentRepositories = content_repositories ? Object.entries(content_repositories).filter(([name]) => name !== "for_each").map(
    ([name, value]) => tfg.data("amplience_content_repository", (0, import_change_case2.snakeCase)(name), {
      id: maybeArg(value)
    })
  ) : void 0;
  const slotRepositories = slot_repositories ? Object.entries(slot_repositories).filter(([name]) => name !== "for_each").map(
    ([name, value]) => tfg.data("amplience_content_repository", (0, import_change_case2.snakeCase)(name), {
      id: maybeArg(value)
    })
  ) : void 0;
  const slotRepositoriesForEach = slot_repositories == null ? void 0 : slot_repositories.for_each;
  const contentRepositoriesForEach = content_repositories == null ? void 0 : content_repositories.for_each;
  (0, import_graphql.visit)(astNode, {
    ObjectTypeDefinition: {
      leave: createObjectTypeVisitor({
        tfg,
        contentRepositories,
        slotRepositories,
        contentRepositoriesForEach,
        slotRepositoriesForEach,
        hostname,
        visualization,
        schemaSuffix
      })
    }
  });
  return tfg.generate().tf;
};
var validate = async (_schema, _documents, config, outputFile) => {
  if ((0, import_path.extname)(outputFile) !== ".tf") {
    throw new Error(
      `Plugin "amplience-terraform" requires output extension to be ".tf"!`
    );
  }
  if (config.visualization) {
    if (config.visualization.filter((v) => v.for_each).length > 1) {
      throw new Error(
        `You can only have 1 item with a for_each property in your visualization list.`
      );
    }
    if (config.visualization.filter((v) => v.default).length > 1 || config.visualization.some((v) => v.default && v.for_each)) {
      throw new Error(
        `You can only set 1 item, which may not be a for_each-item to be the default.`
      );
    }
  }
  if (config.content_repositories) {
    validateRepositoryConfig(config.content_repositories);
  }
  if (config.slot_repositories) {
    validateRepositoryConfig(config.slot_repositories);
  }
};
function validateRepositoryConfig(repositoryMap) {
  const repositoryKeys = Object.keys(repositoryMap);
  if (repositoryKeys.length > 1 && repositoryMap.for_each) {
    throw new Error(
      `for_each should not be used when multiple repositories are defined to prevent duplicate resources.`
    );
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  addToSchema,
  plugin,
  validate
});
//# sourceMappingURL=index.js.map